Index: /trunk/src/org/expeditee/io/ExaWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/ExaWriter.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/ExaWriter.java	(revision 1102)
@@ -29,5 +29,4 @@
 
 import org.expeditee.gui.AttributeUtils;
-import org.expeditee.gui.AttributeUtils.Attribute;
 import org.expeditee.gui.Frame;
 import org.expeditee.items.Constraint;
Index: /trunk/src/org/expeditee/io/ExpClipReader.java
===================================================================
--- /trunk/src/org/expeditee/io/ExpClipReader.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/ExpClipReader.java	(revision 1102)
@@ -25,5 +25,6 @@
 import java.util.List;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Point;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameGraphics;
@@ -37,5 +38,5 @@
 import org.expeditee.items.Line;
 import org.expeditee.items.Text;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 
 /**
@@ -52,4 +53,9 @@
 	private int dX, dY;
 	
+	public ExpClipReader(Point p)
+	{
+		this(p.x, p.y);
+	}
+	
 	public ExpClipReader(int dX, int dY) {
 		super("");
@@ -63,5 +69,5 @@
 	 */
 	public static void updateItems(List<Item> items) {
-		if(FrameGraphics.isXRayMode()) {
+		if(DisplayController.isXRayMode()) {
 			return;
 		}
@@ -72,8 +78,7 @@
 				continue;
 			}
-			if (ItemUtils.startsWithTag(item,
-					ItemUtils.TAG_IMAGE, true)) {
+			if (ItemUtils.startsWithTag(item, ItemUtils.TAG_IMAGE, true)) {
 				if (!item.hasEnclosures()) {
-					items.add(ItemUtils.CreatePicture((Text) item, DisplayIO.getCurrentFrame()));
+					items.add(ItemUtils.CreatePicture((Text) item));
 				}
 				// check for frame images
@@ -83,5 +88,5 @@
 					&& !item.getAbsoluteLink()
 							.equalsIgnoreCase(
-									DisplayIO.getCurrentFrame().getName())) {
+									DisplayController.getCurrentFrame().getName())) {
 				if (item.hasEnclosures()) {
 					// item.setHidden(true);
@@ -90,5 +95,5 @@
 					// image.refresh();
 				} else {
-					items.add(new FrameImage((Text) item, DisplayIO.getCurrentFrame(), null));
+					items.add(new FrameImage((Text) item, null));
 				}
 			} else if (ItemUtils.startsWithTag(item,
@@ -97,5 +102,5 @@
 					&& !item.getAbsoluteLink()
 							.equalsIgnoreCase(
-									DisplayIO.getCurrentFrame().getName())) {
+									DisplayController.getCurrentFrame().getName())) {
 				if (item.hasEnclosures()) {
 					// image =
@@ -107,5 +112,5 @@
 					// frame which already has a bitmap dont
 					// recreate the bitmap
-					items.add(new FrameBitmap((Text) item, DisplayIO.getCurrentFrame(), null));
+					items.add(new FrameBitmap((Text) item, null));
 				}
 			} else if (ItemUtils.startsWithTag(item, "@c")) {
@@ -116,10 +121,9 @@
 				}
 				// Check for interactive widgets
-			} else if (ItemUtils.startsWithTag(item,
-					ItemUtils.TAG_IWIDGET)) {
+			} else if (ItemUtils.startsWithTag(item, ItemUtils.TAG_IWIDGET)) {
 				items.remove(item);
-				item.setParent(DisplayIO.getCurrentFrame());
+				item.setParent(DisplayController.getCurrentFrame());
 				try {
-					items.addAll(InteractiveWidget.createWidget((Text) item).getItems());
+					items.addAll(Widget.createWidget((Text) item).getItems());
 				} catch (Exception e) {
 					System.err.println("Failed to create widget");
@@ -176,10 +180,10 @@
 			while(index < lines.length && !(lines[++index].equals("Z"))) {
 				if (isValidLine(lines[index])) {
-					java.awt.Point idtype = separateValues(lines[index].substring(2));
+					Point idtype = separateValues(lines[index].substring(2));
 					// The next line must be the endpoints
 					if (index >= lines.length)
 						throw new Exception("Unexpected end of file");
 					++index;
-					java.awt.Point startend = separateValues(lines[index].substring(2));
+					Point startend = separateValues(lines[index].substring(2));
 					int start = startend.x;
 					int end = startend.y;
@@ -199,10 +203,10 @@
 			while(index < lines.length && !(lines[++index].equals("Z"))) {
 				if (isValidLine(lines[index])) {
-					java.awt.Point idtype = separateValues(lines[index].substring(2));
+					Point idtype = separateValues(lines[index].substring(2));
 					// The next line must be the endpoints
 					if (index >= lines.length)
 						throw new Exception("Unexpected end of file");
 					++index;
-					java.awt.Point startend = separateValues(lines[index].substring(2));
+					Point startend = separateValues(lines[index].substring(2));
 	
 					Item a = _linePoints.get(startend.x);
Index: /trunk/src/org/expeditee/io/ExpClipWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/ExpClipWriter.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/ExpClipWriter.java	(revision 1102)
@@ -23,9 +23,10 @@
 import java.util.List;
 
+import org.expeditee.core.Point;
 import org.expeditee.gui.Frame;
 import org.expeditee.items.Item;
 import org.expeditee.items.Line;
 import org.expeditee.items.XRayable;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.items.widgets.WidgetCorner;
 import org.expeditee.items.widgets.WidgetEdge;
@@ -41,4 +42,9 @@
 	private int dX, dY;
 
+	public ExpClipWriter(Point p)
+	{
+		this(p.x, p.y);
+	}
+	
 	public ExpClipWriter(int dX, int dY) {
 		super();
@@ -60,5 +66,5 @@
 	public void output(List<Item> items) throws IOException {
 		// switch to savable items
-		LinkedList<InteractiveWidget> widgets = new LinkedList<InteractiveWidget>();
+		LinkedList<Widget> widgets = new LinkedList<Widget>();
 		// make an array to iterate over instead of the list so we don't get stuck when we remove items from the list
 		Item[] tmpitems = items.toArray(new Item[0]);
@@ -72,5 +78,5 @@
 				}
 			} else if (i instanceof WidgetCorner) {
-				InteractiveWidget iw = ((WidgetCorner)i).getWidgetSource();
+				Widget iw = ((WidgetCorner)i).getWidgetSource();
 				if(!widgets.contains(iw)) {
 					widgets.add(iw);
@@ -78,5 +84,5 @@
 				items.remove(i);
 			} else if (i instanceof WidgetEdge) {
-				InteractiveWidget iw = ((WidgetEdge)i).getWidgetSource();
+				Widget iw = ((WidgetEdge)i).getWidgetSource();
 				if(!widgets.contains(iw)) {
 					widgets.add(iw);
@@ -90,5 +96,5 @@
 			}
 		}
-		for (InteractiveWidget iw : widgets) {
+		for (Widget iw : widgets) {
 			items.add(iw.getSource());
 		}
Index: /trunk/src/org/expeditee/io/ExpReader.java
===================================================================
--- /trunk/src/org/expeditee/io/ExpReader.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/ExpReader.java	(revision 1102)
@@ -27,4 +27,5 @@
 import java.util.List;
 
+import org.expeditee.core.Point;
 import org.expeditee.gui.Frame;
 import org.expeditee.items.Constraint;
@@ -130,10 +131,10 @@
 			while (_reader.ready() && !(next = _reader.readLine()).equals("Z")) {
 				if (isValidLine(next)) {
-					java.awt.Point idtype = separateValues(next.substring(2));
+					Point idtype = separateValues(next.substring(2));
 					// The next line must be the endpoints
 					if (!_reader.ready())
 						throw new Exception("Unexpected end of file");
 					next = _reader.readLine();
-					java.awt.Point startend = separateValues(next.substring(2));
+					Point startend = separateValues(next.substring(2));
 					int start = startend.x;
 					int end = startend.y;
@@ -153,10 +154,10 @@
 			while (_reader.ready() && !(next = _reader.readLine()).equals("Z")) {
 				if (isValidLine(next)) {
-					java.awt.Point idtype = separateValues(next.substring(2));
+					Point idtype = separateValues(next.substring(2));
 					// The next line must be the endpoints
 					if (!_reader.ready())
 						throw new Exception("Unexpected end of file");
 					next = _reader.readLine();
-					java.awt.Point startend = separateValues(next.substring(2));
+					Point startend = separateValues(next.substring(2));
 
 					Item a = _linePoints.get(startend.x);
@@ -233,11 +234,9 @@
 
 		Method toRun = _ItemTags.get(tag);
-		if (toRun == null)
-			System.out.println("Error accessing tag method: " + tag);
+		if (toRun == null) System.out.println("Error accessing tag method: " + tag);
 		Object[] vals = Conversion.Convert(toRun, value);
 
 		try {
-			if (vals != null)
-				toRun.invoke(item, vals);
+			if (vals != null) toRun.invoke(item, vals);
 		} catch (Exception e) {
 			System.out.println("Error running tag method: " + tag);
@@ -297,9 +296,9 @@
 
 	// Returns a point from a String containing two ints separated by a space
-	protected java.awt.Point separateValues(String line) {
+	protected Point separateValues(String line) {
 		int x = Integer.parseInt(line.substring(0, line.indexOf(" ")));
 		int y = Integer.parseInt(line.substring(line.indexOf(" ") + 1));
 
-		return new java.awt.Point(x, y);
+		return new Point(x, y);
 	}
 
Index: /trunk/src/org/expeditee/io/HTMLWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/HTMLWriter.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/HTMLWriter.java	(revision 1102)
@@ -19,10 +19,14 @@
 package org.expeditee.io;
 
-import java.awt.Image;
-import java.awt.image.BufferedImage;
 import java.io.IOException;
 import java.util.List;
 
 import org.expeditee.actions.Misc;
+import org.expeditee.core.Dimension;
+import org.expeditee.core.Image;
+import org.expeditee.core.Point;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
+import org.expeditee.gio.swing.SwingMiscManager;
 import org.expeditee.gui.FrameIO;
 import org.expeditee.items.FramePicture;
@@ -65,11 +69,14 @@
 			image = pic.getImage();
 			// Crop the image
-			BufferedImage bufferedImage = new BufferedImage(pic
-					.getUnscaledWidth(), pic.getUnscaledHeight(),
-					BufferedImage.TYPE_INT_ARGB);
-			bufferedImage.getGraphics().drawImage(image, 0, 0,
-					pic.getUnscaledWidth(), pic.getUnscaledHeight(),
-					pic.getStart().x, pic.getStart().y, pic.getEnd().x,
-					pic.getEnd().y, null);
+			Image bufferedImage = Image.createImage(pic.getUnscaledWidth(), pic.getUnscaledHeight());
+			GraphicsManager g = EcosystemManager.getGraphicsManager();
+			g.pushDrawingSurface(bufferedImage);
+			g.drawImage(image,
+						new Point(0, 0),
+						new Dimension(pic.getUnscaledWidth(), pic.getUnscaledHeight()),
+						0.0,
+						pic.getStart(),
+						new Dimension(pic.getEnd().x - pic.getStart().x, pic.getEnd().y - pic.getStart().y));
+			g.popDrawingSurface();
 			image = bufferedImage;
 		} else {
@@ -81,10 +88,9 @@
 		// If its a bufferedImage then just write it out to the files directory
 		// This means it is probably a FrameImage
-		if (image instanceof BufferedImage) {
+		if (!image.isStoredOnDisk()) {
 			String link = pic.getAbsoluteLink();
-			// Account for the possiblitly of an unlinked buffered image
+			// Account for the possibility of an unlinked buffered image
 			fileName = link == null ? ("Image" + pic.getID()) : link;
-			fileName = Misc.SaveImage((BufferedImage) image, "PNG",
-					FrameIO.EXPORTS_DIR + filesFolder, fileName);
+			fileName = Misc.SaveImage(image, "PNG",	FrameIO.EXPORTS_DIR + filesFolder, fileName);
 		} else {// It is a normal Image stored somewhere
 			fileName = pic.getName();
Index: /trunk/src/org/expeditee/io/ItemSelection.java
===================================================================
--- /trunk/src/org/expeditee/io/ItemSelection.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/ItemSelection.java	(revision 1102)
@@ -19,25 +19,17 @@
 package org.expeditee.io;
 
-
-import java.awt.Image;
-import java.awt.Toolkit;
-import java.awt.datatransfer.Clipboard;
-import java.awt.datatransfer.DataFlavor;
-import java.awt.datatransfer.Transferable;
-import java.awt.datatransfer.UnsupportedFlavorException;
-import java.awt.image.BufferedImage;
 import java.io.File;
 import java.io.IOException;
 import java.io.Serializable;
 import java.util.ArrayList;
-import java.util.Arrays;
 import java.util.List;
 
-import javax.imageio.ImageIO;
-
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Image;
+import org.expeditee.gio.ClipboardManager.ClipboardData;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.FreeItems;
 import org.expeditee.gui.MessageBay;
@@ -53,6 +45,6 @@
  * @author jts21
  */
-public class ItemSelection implements Transferable {
-	
+public class ItemSelection {
+	// TODO : Tidy commented code once tested. cts16
 	/**
 	 * Class used for storing data which can be used to reconstruct expeditee objects from the clipboard
@@ -68,57 +60,8 @@
 		// exp save data
 		public String items;
-	}
-	
-	public static final DataFlavor expDataFlavor = new DataFlavor(ExpDataHandler.class, "expDataHandler");
-	
-	private static final int STRING = 0;
-    private static final int IMAGE = 1;
-    private static final int EXP_DATA = 2;
-	
-	private static final DataFlavor[] flavors = {
-        DataFlavor.stringFlavor,
-        DataFlavor.imageFlavor,
-        expDataFlavor
-    };
-	
-	private String data;
-	private Image image;
-	private ExpDataHandler expData;
-	
-	public ItemSelection(String data, Image image, ExpDataHandler expData) {
-        this.data = data;
-        this.image = image;
-        this.expData = expData;
-    }
-	
-	@Override
-	public DataFlavor[] getTransferDataFlavors() {
-		return (DataFlavor[])flavors.clone();
-	}
-
-	@Override
-	public boolean isDataFlavorSupported(DataFlavor flavor) {
-		for (int i = 0; i < flavors.length; i++) {
-            if (flavor.equals(flavors[i])) {
-                return true;
-            }
-        }
-        return false;
-	}
-
-	@Override
-	public Object getTransferData(DataFlavor flavor)
-			throws UnsupportedFlavorException, IOException {
-        if (flavor.equals(flavors[STRING])) {
-            return (Object)data;
-        } else if (flavor.equals(flavors[IMAGE])) {
-        	return (Object)image;
-        } else if (flavor.equals(flavors[EXP_DATA])) {
-            return (Object)expData;
-        } else {
-            throw new UnsupportedFlavorException(flavor);
-        }
-	}
-	
+		public Image image;
+		public String text;
+	}
+
 	private static List<Item> getAllToCopy() {
 		List<Item> tmp = new ArrayList<Item>(FreeItems.getInstance());
@@ -128,5 +71,5 @@
 				if(! toCopy.contains(c)) {
 					toCopy.add(c);
-					FrameMouseActions.pickup(c);
+					StandardGestureActions.pickup(c);
 				}
 			}
@@ -142,8 +85,8 @@
 		
 		// remove the items attached to the cursor
-		DisplayIO.getCurrentFrame().removeAllItems(toCopy);
+		DisplayController.getCurrentFrame().removeAllItems(toCopy);
 		FreeItems.getInstance().clear();
 		
-		FrameGraphics.refresh(false);
+		DisplayController.requestRefresh(false);
 	}
 	
@@ -161,5 +104,5 @@
 			return;
 		}
-		
+
 		StringBuilder clipboardText = new StringBuilder();
 		ExpDataHandler expData = new ExpDataHandler();
@@ -179,5 +122,5 @@
 		
 		// get expeditee item data
-		ExpClipWriter ecw = new ExpClipWriter(FrameMouseActions.getX(), FrameMouseActions.getY());
+		ExpClipWriter ecw = new ExpClipWriter(EcosystemManager.getInputManager().getCursorPosition());
 		try {
 			ecw.output(items);
@@ -186,9 +129,16 @@
 		}
 		expData.items = ecw.getFileContents();
+		expData.image = image;
+		expData.text = clipboardText.toString();
+		
+		// Format the data for the clipboard
+		ClipboardData clipboardData = new ClipboardData(expData, expData.image, expData.text);
+		
 		// System.out.println(expData.items); 
-		
+
 		// write out to clipboard
-		ItemSelection selection = new ItemSelection(clipboardText.toString(), image, expData);
-		Toolkit.getDefaultToolkit().getSystemClipboard().setContents(selection, null);
+		//ItemSelection selection = new ItemSelection(clipboardText.toString(), image, expData);
+		//Toolkit.getDefaultToolkit().getSystemClipboard().setContents(selection, null);
+		EcosystemManager.getClipboardManager().set(clipboardData);
 	}
 	
@@ -196,7 +146,8 @@
 	 * Generates items from the clipboard data
 	 *  TODO: Enable pasting raw image data (would require saving the data as an image file and generating a Text item pointing to it)
+	 *  TODO: Above TODO seems to be done? cts16
 	 */
 	public static void paste() {
-		if(FreeItems.itemsAttachedToCursor()) {
+		if(FreeItems.hasItemsAttachedToCursor()) {
 			MessageBay.displayMessage("Drop any items being carried on the cursor, then try pasting again");
 			return;
@@ -204,29 +155,32 @@
 		String type = "";
 		FreeItems f = FreeItems.getInstance();
-		Clipboard c = Toolkit.getDefaultToolkit().getSystemClipboard();
-		Transferable content = c.getContents(null);
+		//Clipboard c = Toolkit.getDefaultToolkit().getSystemClipboard();
+		//Transferable content = c.getContents(null);
+		ClipboardData content = EcosystemManager.getClipboardManager().get();
+		
 		try {
-			if(content.isDataFlavorSupported(ItemSelection.expDataFlavor)) {	// Expeditee data
+			if (content.data instanceof ExpDataHandler) {	// Expeditee data
 				type = "Expeditee ";
-				ExpDataHandler expData = (ExpDataHandler)content.getTransferData(ItemSelection.expDataFlavor);
+				ExpDataHandler expData = (ExpDataHandler) content.data;
 				if(expData != null) {
-					List<Item> items = new ExpClipReader(FrameMouseActions.getX(), FrameMouseActions.getY()).read(expData.items);
+					List<Item> items = new ExpClipReader(EcosystemManager.getInputManager().getCursorPosition()).read(expData.items);
 					// generate new IDs and pickup
-					FrameMouseActions.pickup(ItemUtils.CopyItems(items));
+					StandardGestureActions.pickup(ItemUtils.CopyItems(items));
 				}
-			} else if(content.isDataFlavorSupported(DataFlavor.imageFlavor)) {	// Image data
+			} else if (content.imageRepresentation != null) {	// Image data
 				// System.out.println("IZ PIKTUR");
 				type = "Image ";
-				BufferedImage img = (BufferedImage)content.getTransferData(DataFlavor.imageFlavor);
-				int hashcode = Arrays.hashCode(img.getData().getPixels(0, 0, img.getWidth(), img.getHeight(), (int[])null));
+				Image img = content.imageRepresentation;
+				//int hashcode = Arrays.hashCode(img.getData().getPixels(0, 0, img.getWidth(), img.getHeight(), (int[])null));
+				int hashcode = img.hashCode();
 				File out = new File(FrameIO.IMAGES_PATH + Integer.toHexString(hashcode) + ".png");
 				out.mkdirs();
-				ImageIO.write(img, "png", out);
-				Text item = DisplayIO.getCurrentFrame().createNewText("@i: " + out.getPath());
+				img.writeToDisk("png", out);
+				Text item = DisplayController.getCurrentFrame().createNewText("@i: " + out.getPath());
 				f.add(item);
 				ExpClipReader.updateItems(f);
-			} else if(content.isDataFlavorSupported(DataFlavor.stringFlavor)) {	// Plain text
+			} else if (content.stringRepresentation != null) {	// Plain text
 				type = "Plain Text ";
-				String clip = ((String) content.getTransferData(DataFlavor.stringFlavor));
+				String clip = content.stringRepresentation;
 				// Covert the line separator char when pasting in
 				// windows (\r\n) or max (\r)
@@ -235,7 +189,7 @@
 				String[] items = clip.split("\n\n");
 				Item item, prevItem = null;
-				final int x = DisplayIO.getMouseX();
-				final int y = DisplayIO.getMouseY();
-				final Text template = DisplayIO.getCurrentFrame().getItemTemplate();
+				final int x = DisplayController.getMouseX();
+				final int y = DisplayController.getMouseY();
+				final Text template = DisplayController.getCurrentFrame().getItemTemplate();
 				for(int i = 0; i < items.length; i++) {
 					// System.out.println(items[i]);
Index: /trunk/src/org/expeditee/io/ItemWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/ItemWriter.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/ItemWriter.java	(revision 1102)
@@ -28,5 +28,5 @@
 import org.expeditee.items.Picture;
 import org.expeditee.items.Text;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.items.widgets.WidgetEdge;
 
@@ -115,5 +115,5 @@
 	}
 
-	protected void writeWidget(InteractiveWidget toWrite) throws IOException {
+	protected void writeWidget(Widget toWrite) throws IOException {
 	}
 
Index: /trunk/src/org/expeditee/io/JavaWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/JavaWriter.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/JavaWriter.java	(revision 1102)
@@ -19,33 +19,11 @@
 package org.expeditee.io;
 
-import java.awt.Desktop;
-import java.awt.Point;
-import java.awt.Polygon;
-import java.awt.Rectangle;
-import java.awt.geom.Area;
-import java.io.File;
 import java.io.IOException;
 import java.io.Writer;
-import java.lang.reflect.Array;
-import java.util.ArrayList;
-import java.util.Collection;
-import java.util.Collections;
-import java.util.Comparator;
 import java.util.List;
 
-import org.expeditee.gui.Browser;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameUtils;
-import org.expeditee.io.flowlayout.AreaPolygon;
-import org.expeditee.io.flowlayout.DimensionExtent;
 import org.expeditee.io.flowlayout.XGroupItem;
-import org.expeditee.io.flowlayout.XItem;
-import org.expeditee.io.flowlayout.XOrderedLine;
-import org.expeditee.io.flowlayout.XRawItem;
-import org.expeditee.io.flowlayout.YOverlappingItemsShadow;
-import org.expeditee.io.flowlayout.YOverlappingItemsSpan;
-import org.expeditee.io.flowlayout.YOverlappingItemsTopEdge;
 import org.expeditee.items.Item;
-import org.expeditee.items.ItemUtils;
 import org.expeditee.items.Text;
 
Index: /trunk/src/org/expeditee/io/KMSReader.java
===================================================================
--- /trunk/src/org/expeditee/io/KMSReader.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/KMSReader.java	(revision 1102)
@@ -29,9 +29,9 @@
 import java.util.LinkedHashMap;
 
+import org.expeditee.core.Point;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.MessageBay;
 import org.expeditee.items.Constraint;
 import org.expeditee.items.Dot;
-import org.expeditee.items.DotType;
 import org.expeditee.items.Item;
 import org.expeditee.items.Line;
@@ -107,5 +107,5 @@
 			_ItemTags.put("e", Item.class.getMethod("setFillColor", pColor));
 			_ItemTags.put("E", Item.class.getMethod("setGradientColor", pColor));
-			_ItemTags.put("Q", Item.class.getMethod("setGradientAngle", pInt));
+			_ItemTags.put("Q", Item.class.getMethod("setGradientAngle", pDouble));
 			
 			_ItemTags.put("i", Item.class.getMethod("setFillPattern", pString));
@@ -267,5 +267,5 @@
 
 		// get the line ID and type
-		java.awt.Point idtype = separateValues(s);
+		Point idtype = separateValues(s);
 
 		// get the end points
@@ -273,5 +273,5 @@
 		_data.remove("s");
 
-		java.awt.Point startend = separateValues(s);
+		Point startend = separateValues(s);
 
 		int start = startend.x;
@@ -299,6 +299,6 @@
 	 */
 	private void createConstraint() {
-		java.awt.Point idtype = separateValues(_data.get("C"));
-		java.awt.Point startend = separateValues(_data.get("s"));
+		Point idtype = separateValues(_data.get("C"));
+		Point startend = separateValues(_data.get("s"));
 
 		Item a = _linePoints.get(startend.x);
@@ -398,9 +398,9 @@
 
 	// returns two ints separated by a space from the given String
-	private java.awt.Point separateValues(String line) {
+	private Point separateValues(String line) {
 		int x = Integer.parseInt(line.substring(0, line.indexOf(" ")));
 		int y = Integer.parseInt(line.substring(line.indexOf(" ") + 1));
 
-		return new java.awt.Point(x, y);
+		return new Point(x, y);
 	}
 
Index: /trunk/src/org/expeditee/io/PDF2Writer.java
===================================================================
--- /trunk/src/org/expeditee/io/PDF2Writer.java	(revision 1101)
+++ /trunk/src/org/expeditee/io/PDF2Writer.java	(revision 1102)
@@ -19,9 +19,4 @@
 package org.expeditee.io;
 
-import java.awt.Color;
-import java.awt.Dimension;
-import java.awt.Image;
-import java.awt.Polygon;
-import java.awt.geom.AffineTransform;
 import java.io.FileOutputStream;
 import java.io.IOException;
@@ -34,4 +29,11 @@
 import java.util.Set;
 
+import org.expeditee.core.Colour;
+import org.expeditee.core.Dimension;
+import org.expeditee.core.Image;
+import org.expeditee.core.bounds.PolygonBounds;
+import org.expeditee.gio.swing.SwingConversions;
+import org.expeditee.gio.swing.SwingMiscManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameGraphics;
@@ -145,5 +147,5 @@
 
 	public PDF2Writer() {
-		_pageSize = FrameGraphics.getMaxSize();
+		_pageSize = DisplayController.getFramePaintArea().getSize();
 		_pdfDocument = new Document(new Rectangle(_pageSize.width, _pageSize.height));
 	}
@@ -233,5 +235,5 @@
 		// set bg color
 		PdfContentByte cb = _pdfWriter.getDirectContent();
-		cb.setColorFill(starting.getPaintBackgroundColor());
+		cb.setColorFill(SwingConversions.toSwingColor(starting.getPaintBackgroundColor()));
 		cb.rectangle(0, 0, _pageSize.width, _pageSize.height);
 		cb.fill();
@@ -239,16 +241,16 @@
 	}
 	
-	private void drawPolygon(PdfContentByte cb, Polygon poly, Color fill, Color line, float lineThickness) {
+	private void drawPolygon(PdfContentByte cb, PolygonBounds poly, Colour fill, Colour line, float lineThickness) {
 		if(poly != null) {
-			cb.moveTo(poly.xpoints[0], _height - poly.ypoints[0]);
-			for(int i = 1; i < poly.npoints; i++) {
-				cb.lineTo(poly.xpoints[i], _height - poly.ypoints[i]);
+			cb.moveTo(poly.toArray()[0].x, _height - poly.toArray()[0].y);
+			for(int i = 1; i < poly.toArray().length; i++) {
+				cb.lineTo(poly.toArray()[i].x, _height - poly.toArray()[i].y);
 			}
 			cb.closePath();
 			if(fill != null) {
-				cb.setColorFill(fill);
+				cb.setColorFill(SwingConversions.toSwingColor(fill));
 				if(lineThickness > 0) {
     				cb.setLineWidth(lineThickness);
-    				cb.setColorStroke(line);
+    				cb.setColorStroke(SwingConversions.toSwingColor(line));
     				cb.fillStroke();
     			} else {
@@ -257,5 +259,5 @@
 			} else {
 				cb.setLineWidth(lineThickness);
-				cb.setColorStroke(line);
+				cb.setColorStroke(SwingConversions.toSwingColor(line));
 				cb.stroke();
 			}
@@ -269,7 +271,6 @@
 		if (hasLink) {
 			
-			Color lineColor = Color.BLACK, fillColor = null;
-			Polygon poly = i.getLinkPoly();
-			poly = new Polygon(poly.xpoints, poly.ypoints, poly.npoints);
+			Colour lineColor = Colour.BLACK, fillColor = null;
+			PolygonBounds poly = new PolygonBounds(i.getLinkBounds().getPolygon(16));
 			poly.translate((int) (x - Item.LEFT_MARGIN), (int) (_height - y - i.getBoundsHeight() / 2));
 			
@@ -298,7 +299,8 @@
 	protected void writeText(Text text) throws IOException {
 		PdfContentByte cb = _pdfWriter.getDirectContent();
-		Font font = FontFactory.getFont(
-				Conversion.getPdfFont(text.getFamily()), text.getSize(), text
-						.getPaintFont().getStyle(), text.getPaintColor());
+		Font font = FontFactory.getFont(Conversion.getPdfFont(text.getFamily()),
+										text.getSize(),
+										SwingConversions.toSwingFontStyle(text.getPaintFont().getStyle()),
+										SwingConversions.toSwingColor(text.getPaintColor()));
 		
 		// we draw some text on a certain position
@@ -318,5 +320,5 @@
 		try {
 			PdfContentByte cb = _pdfWriter.getDirectContent();
-			com.lowagie.text.Image iTextImage = com.lowagie.text.Image.getInstance(image, null);
+			com.lowagie.text.Image iTextImage = com.lowagie.text.Image.getInstance(SwingMiscManager.getIfUsingSwingImageManager().getInternalImage(image), null);
 			float angle = (float) (pic.getRotate() * Math.PI / 180);
 			double sin = Math.sin(angle), cos = Math.cos(angle);
@@ -339,8 +341,8 @@
 		PdfContentByte cb = _pdfWriter.getDirectContent();
 		cb.circle(circle.getCenter().getX(), _pdfWriter.getPageSize().getHeight() - circle.getCenter().getY(), (float) circle.getRadius());
-		cb.setColorFill(circle.getFillColor());
+		cb.setColorFill(SwingConversions.toSwingColor(circle.getFillColor()));
 		if(circle.getThickness() > 0) {
 			cb.setLineWidth(circle.getThickness());
-			cb.setColorStroke(circle.getPaintColor());
+			cb.setColorStroke(SwingConversions.toSwingColor(circle.getPaintColor()));
 			cb.fillStroke();
 		} else {
@@ -377,10 +379,10 @@
 			}
 			cb.closePath();
-			Color fill = currentItem.getFillColor();
+			Colour fill = currentItem.getFillColor();
 			if(fill != null) {
-    			cb.setColorFill(fill);
+    			cb.setColorFill(SwingConversions.toSwingColor(fill));
     			if(currentItem.getThickness() > 0) {
     				cb.setLineWidth(currentItem.getThickness());
-    				cb.setColorStroke(currentLine.getPaintColor());
+    				cb.setColorStroke(SwingConversions.toSwingColor(currentLine.getPaintColor()));
     				cb.fillStroke();
     			} else {
@@ -389,5 +391,5 @@
 			} else if(currentItem.getThickness() > 0) {
 				cb.setLineWidth(currentItem.getThickness());
-				cb.setColorStroke(currentLine.getPaintColor());
+				cb.setColorStroke(SwingConversions.toSwingColor(currentLine.getPaintColor()));
 				cb.stroke();
 			}
@@ -403,5 +405,5 @@
 					if(l.getThickness() >= 0) {
 						cb.setLineWidth(l.getThickness());
-						cb.setColorStroke(l.getPaintColor());
+						cb.setColorStroke(SwingConversions.toSwingColor(l.getPaintColor()));
 						cb.stroke();
 					}
